<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Nano102_112 Series BSP: StdDriver/src/gpio.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="M0Banner_v2.jpg"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Nano102_112 Series BSP
   &#160;<span id="projectnumber">V3.03.002</span>
   </div>
   <div id="projectbrief">The Board Support Package for  Nano102_112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">gpio.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="gpio_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**************************************************************************/</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">   40</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a>(<a class="code" href="struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32PinMask, uint32_t u32Mode)</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;{</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    uint32_t i;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">for</span> (i=0; i&lt;<a class="code" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gad5df1f52a4cc540fc739f23056584a04">GPIO_PIN_MAX</a>; i++)</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keywordflow">if</span> (u32PinMask &amp; (1 &lt;&lt; i))</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        {</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;            gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#a1d09c59b4451ee8cc8736c8078891386">PMD</a> = (gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#a1d09c59b4451ee8cc8736c8078891386">PMD</a> &amp; ~(0x3 &lt;&lt; (i &lt;&lt; 1))) | (u32Mode &lt;&lt; (i &lt;&lt; 1));</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        }</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    }</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;}</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">   65</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">GPIO_EnableInt</a>(<a class="code" href="struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32Pin, uint32_t u32IntAttribs)</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;{</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#a238fd487ce9252ecbab0003630cdeb27">IMD</a> |= (((u32IntAttribs &gt;&gt; 24) &amp; 0xFFUL) &lt;&lt; u32Pin);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#aa332e6a57141c2ae9a44acc296a8ca18">IER</a> |= ((u32IntAttribs &amp; 0xFFFFFFUL) &lt;&lt; u32Pin);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">   82</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">GPIO_DisableInt</a>(<a class="code" href="struct_g_p_i_o___t.html">GPIO_T</a> *gpio, uint32_t u32Pin)</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;{</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#a238fd487ce9252ecbab0003630cdeb27">IMD</a> &amp;= ~(1UL &lt;&lt; u32Pin);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    gpio-&gt;<a class="code" href="struct_g_p_i_o___t.html#aa332e6a57141c2ae9a44acc296a8ca18">IER</a> &amp;= ~((0x00010001UL) &lt;&lt; u32Pin);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;}</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; <span class="comment">/* end of group NANO1X2_GPIO_EXPORTED_FUNCTIONS */</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; <span class="comment">/* end of group NANO1X2_GPIO_Driver */</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; <span class="comment">/* end of group NANO1X2_Device_Driver */</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">/*** (C) COPYRIGHT 2014 Nuvoton Technology Corp. ***/</span></div><div class="ttc" id="struct_g_p_i_o___t_html"><div class="ttname"><a href="struct_g_p_i_o___t.html">GPIO_T</a></div><div class="ttdef"><b>Definition:</b> <a href="_nano1_x2_series_8h_source.html#l04074">Nano1X2Series.h:4074</a></div></div>
<div class="ttc" id="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa2d25bd7fd805f81e465e5f2f0f43123"><div class="ttname"><a href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa2d25bd7fd805f81e465e5f2f0f43123">GPIO_SetMode</a></div><div class="ttdeci">void GPIO_SetMode(GPIO_T *gpio, uint32_t u32PinMask, uint32_t u32Mode)</div><div class="ttdoc">Set GPIO operation mode.</div><div class="ttdef"><b>Definition:</b> <a href="gpio_8c_source.html#l00040">gpio.c:40</a></div></div>
<div class="ttc" id="struct_g_p_i_o___t_html_a238fd487ce9252ecbab0003630cdeb27"><div class="ttname"><a href="struct_g_p_i_o___t.html#a238fd487ce9252ecbab0003630cdeb27">GPIO_T::IMD</a></div><div class="ttdeci">__IO uint32_t IMD</div><div class="ttdef"><b>Definition:</b> <a href="_nano1_x2_series_8h_source.html#l04315">Nano1X2Series.h:4315</a></div></div>
<div class="ttc" id="_nano1_x2_series_8h_html"><div class="ttname"><a href="_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gad5df1f52a4cc540fc739f23056584a04"><div class="ttname"><a href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gad5df1f52a4cc540fc739f23056584a04">GPIO_PIN_MAX</a></div><div class="ttdeci">#define GPIO_PIN_MAX</div><div class="ttdef"><b>Definition:</b> <a href="gpio_8h_source.html#l00032">gpio.h:32</a></div></div>
<div class="ttc" id="struct_g_p_i_o___t_html_a1d09c59b4451ee8cc8736c8078891386"><div class="ttname"><a href="struct_g_p_i_o___t.html#a1d09c59b4451ee8cc8736c8078891386">GPIO_T::PMD</a></div><div class="ttdeci">__IO uint32_t PMD</div><div class="ttdef"><b>Definition:</b> <a href="_nano1_x2_series_8h_source.html#l04213">Nano1X2Series.h:4213</a></div></div>
<div class="ttc" id="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga675532237c47dd6f69f325e27fd2e7e0"><div class="ttname"><a href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga675532237c47dd6f69f325e27fd2e7e0">GPIO_DisableInt</a></div><div class="ttdeci">void GPIO_DisableInt(GPIO_T *gpio, uint32_t u32Pin)</div><div class="ttdoc">Disable GPIO interrupt.</div><div class="ttdef"><b>Definition:</b> <a href="gpio_8c_source.html#l00082">gpio.c:82</a></div></div>
<div class="ttc" id="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaec751ab5c00bcad980d782816df53cbd"><div class="ttname"><a href="group___n_a_n_o1_x2___g_p_i_o___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaec751ab5c00bcad980d782816df53cbd">GPIO_EnableInt</a></div><div class="ttdeci">void GPIO_EnableInt(GPIO_T *gpio, uint32_t u32Pin, uint32_t u32IntAttribs)</div><div class="ttdoc">Enable GPIO interrupt.</div><div class="ttdef"><b>Definition:</b> <a href="gpio_8c_source.html#l00065">gpio.c:65</a></div></div>
<div class="ttc" id="struct_g_p_i_o___t_html_aa332e6a57141c2ae9a44acc296a8ca18"><div class="ttname"><a href="struct_g_p_i_o___t.html#aa332e6a57141c2ae9a44acc296a8ca18">GPIO_T::IER</a></div><div class="ttdeci">__IO uint32_t IER</div><div class="ttdef"><b>Definition:</b> <a href="_nano1_x2_series_8h_source.html#l04613">Nano1X2Series.h:4613</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 6 2020 19:17:53 for Nano102_112 Series BSP by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
